from visual import *
from visual.controls import *

#import math

grey=(0.85,0.85,0.85)

class EMwave:
    def __init__(self, StartPos=vector(0,0,0), PolDir=vector(0,1,0), Amplitude = 1,
                 K_Vector = vector(0,0,1), Length = 20.0, phase = 0, color=(0,1,0)):
        nVecNorm=20
        lamb = 2*pi/mag(K_Vector)
        self.PolDir=PolDir
        self.K_Vector=K_Vector
        self.Amplitude=Amplitude
        self.dVecPos=norm(K_Vector)*2*pi/nVecNorm
        self.nVec=int(floor(Length/mag(self.dVecPos)))
        self.StartPos = vector(StartPos)
        self.PhiStart = phase
        self.PolDir=PolDir
        self.Amplitude=Amplitude
        #self.ELength=1
        self.Evecs = []
        for i in range(self.nVec):
                    arrowpos = self.StartPos+i*self.dVecPos
                    self.Evecs.append( arrow( pos=arrowpos, axis=self.PolDir, 
        			color = color, shaftwidth = 0.1 , fixedwidth = 1) )
        
    def CalcField(self,omega,t):
        for i in range(self.nVec):
            actpos=i*self.dVecPos
            ELength=self.Amplitude*sin( dot(self.K_Vector,actpos)-omega*t-self.PhiStart)
            self.Evecs[i].axis = self.PolDir
            self.Evecs[i].length=ELength

def setphase(obj): # called on slider drag events
    if obj is s1:
        Efeld2.PhiStart = obj.value
    else:
        Efeld2.Amplitude = (1-s2.value)*Efeld1.Amplitude

def nothing(obj):
    c=obj.value

## create slider window
c = controls(x=0, y=0, width=200, height=370, range=60, title = "phi_A")
s1 = slider(pos=(-15,-50), width=10, length=100, axis=(0,1,0), text = 'phase (0..180)',   min=0, max=2*pi, action=lambda: setphase(s1))
s2 = slider(pos=(15,-50), width=10, length=100, axis=(0,1,0), text = 'amplitude (0..1)', min=0, max=1, action=lambda: setphase(s2))
text1 = button( pos=(-15,55), width=30, height=1.2, text='phase 2', action=lambda: nothing(text1) )
text2 = button( pos=(15,55), width=30, height=1.2, text='amplitude 2', action=lambda: nothing(text2) )
#----------------------------------------------------------------------------------------------

scene.width = 1000
scene.height = 1000
scene.center = (0,0,0)
scene.forward = (0,-0.3,-1)
scene.background = (0,0,0)
scene.x=200
scene.y=0
scene.select()
scene.autoscale=0
scene.title = "berlagerung zweier linear polarisierter Wellen"
scene.visible=1

#----------------------------------------------------------------------------------------------
#Mit lam_rel wird der Brechungsindex fr die zwei Teilwellen eingestellt.
#Wenn Sie lam_rel ungleich 1 setzen, knnen Sie den bergang einer linear polarisierten
#Welle in eine zurkular polarisierte ... beobachten.

lam_rel=1.02
#----------------------------------------------------------------------------------------------
LLength=60
Kdirection=norm(vector(1,0,1))              # Richtung der Welle
Startpositrue=(-1/2)*Kdirection*LLength     # Zentrierung um Null fr Bewqemlichkeit bei Betrachtung

# first linear polarized wave
Efeld1 = EMwave(StartPos=vector(-30,0,0), PolDir=vector(0,1,0), Amplitude = 5,
                 K_Vector = Kdirection, Length = LLength, phase = 0, color=(1,0,0))
Efeld1.CalcField(1,0)

# second linear polarized wave
Efeld2 = EMwave(StartPos=vector(-30,0,0), PolDir=cross(vector(0,1,0),Kdirection), Amplitude = 5,
                 K_Vector = lam_rel*Kdirection, Length = LLength, phase = 0, color=(0,0,1))
Efeld2.CalcField(1,0)

# sum of E1 and E2
Efeld3 = EMwave(StartPos=vector(-30,0,0), PolDir=vector(0,0,1), Amplitude = 5,
                 K_Vector = Kdirection, Length = LLength, phase = 0, color=(1,0,1))
Efeld3.CalcField(1,0)
#----------------------------------------------------------------------------------------------


scene.autoscale=1
scene.autoscale=0
t=0
dt=.1
while 1:
    rate(10)
    Efeld1.CalcField(1,t)
    Efeld2.CalcField(1,t)
    for i in range(Efeld1.nVec):
        Efeld3.Evecs[i].axis=Efeld1.Evecs[i].axis+Efeld2.Evecs[i].axis
    t=t+dt
    if scene.kb.keys:
        s= scene.kb.getkey()
        if s=='up':
            scene.center=scene.center-vector(0,1,0)
        elif s=='down':
            scene.center=scene.center+vector(0,1,0)
        elif s=='right':
            scene.center=scene.center-vector(1,0,0)
        elif s=='left':
            scene.center=scene.center+vector(1,0,0)

        else: s=scene.kb.getkey()
    c.interact()
